
      PROGRAM	 TABS


$NOTSTRICT

C
C
C     A GENERAL PROGRAM FOR THE STATIC AND DYNAMIC ANALYSIS OF FRAME
C     AND SHEAR WALL THREE-DIMENSIONAL BUILDINGS--- E WILSON AND H DOVEY
C     8 MARCH 1972---UCB.
C     MODIFIED AUGUST 72 TO INCLUDE RESPONSE ANALYSIS OPTION
C
      COMMON /GEN/ NST,NDF,NTF,NLD,NAT,NFQ,NSD,BHED(9),FHED(9),NSS,I3,IS
     1		  ,RLAB(3)
      COMMON /GROUP1/ T(6)
      COMMON /JUNK1/JNK(130)
      COMMON /DYN/ NTIME,DT,NPC,DAMP
      COMMON /GROUP2/A(3000)

C     DATA RLAB /4H  X ,4H  Y ,4HROTN / *****************************

      MTOT=3000
C
C     READ AND PRINT OF GENERAL INFORMATION
C
      CALL TITLE

100   READ  (5,1000) NST,NDF,NTF,NLD,NAT,NFQ,NSD,BHED

      IF(NST.EQ.0) STOP
      CALL SECOND (T(1))
      I3=3
      IS=0
      IF(NSD.EQ.0) GO TO 50
      I3=1
      IS=NSD-1
   50 NSS=NST*I3
      IF(NFQ.GT.NSS) NFQ=NSS
      IF(NAT.EQ.0) NFQ=0
      WRITE  (6,2000) BHED,NST,NDF,NTF,NLD,NAT,NFQ,NSD
      REWIND 2
      REWIND 3
C
C     READ AND PRINT OF STORY INFORMATION
C
      N2=1+14*NST
      N3=N2+2*NST
      CALL TABI (A(1),A(N2),A(N3),NST)
C
C     READ AND PRINT OF FRAME PROPERTIES AND FORM LATERAL STIFFNESSES
C
      DO 200 I=1,NDF
      CALL SECOND (TT)
      READ  (5,1000) M,NC,NS,NCP,NBP,NFEF,NPAN,FHED
      WRITE (6,2001) FHED,M,NC,NS,NCP,NBP,NFEF,NPAN
C
      NB=NC-1
      NCP=NCP+1
      NBP=NBP+1
      NN=4*NC+NS+1
      N1=1
      N2=N1+14*NST
      N3=N2+NB
      N4=N3+5*NCP
      N5=N4+5*NBP
      N6=N5+7*NFEF
      N7=N6+NB*NS
      N8=N7+NS*NB*3
      N9=N8+NS*NC
      N10=N9+2*NPAN
      N11=N10+NN*NN
      N12=N11+3*NN
      N13=N12+NFEF
      N14=N13+5*NPAN
      IF(N14.GT.MTOT) CALL TABR (N14-MTOT)
      CALL TABF(A(N1),A(N2),A(N3),A(N4),A(N5),A(N6),A(N7),A(N8),A(N9),
     1 A(N10),A(N11),NST,NB,NC,NCP,NBP,NS,NFEF,NPAN,A(N12),A(N13),NN,I)
      CALL SECOND (TTT)
      TTT=TTT-TT
      WRITE (6,2003) I,TTT
  200 CONTINUE
      CALL SECOND (T(2))
C
C     SOLVE STATIC LOAD CASES
C
      N3=N2+NSS*NSS
      N4=N3+5*NSS
      N5=N4+((NST+1)*NST)/2
      N6=N5+3*NST
      N7=N6+NST*NTF
      N8=N7+5*NTF
      N9=N8+4*NTF
      IF(N9.GT.MTOT) CALL TABR (N9-MTOT)
      CALL TABL (A(N1),A(N2),A(N3),A(N4),A(N5),A(N6),A(N7),NSS,NST,NTF,
     1	A(N8))
      CALL SECOND (T(3))
C
C     MODE SHAPES AND FREQUENCIES AND SPECTRUM RESPONSE
C
      N2=N1+8*NST
      N3=N2+NSS*NSS
      N4=N3+NSS
      N5=N4+NSS
      N6=N5+NSS
      N7=N6+NSS*NSS
      N8=N2+(NFQ+5)*NSS
      IF(N8.GT.N7) N7=N8
      IF(N7.GT.MTOT) CALL TABR (N7-MTOT)
      CALL TABE (A(N1),A(N2),A(N3),A(N4),A(N5),A(N6),A(N6),NSS,NST)
C
C     COMPUTE DYNAMIC RESPONSE
C
      IF (NAT.NE.4) GO TO 250
      MLD=5+NTIME
      N3=N2+MLD*NSS
      N4=N3+2*NPC
      N5=N4+NTIME
      N6=N5+NSS
      IF (N6.GT.MTOT) CALL TABR (N6-MTOT)
      CALL TABDY(A(N2),A(N3), A(N4), A(N5),NSS)
  250 CALL SECOND (T(4))
C
C     COMPUTE FRAME DISPLACEMENTS
C
      IF(NAT.LE.2) NFQ=0
      IF (NAT.EQ.1) GO TO 300
      MLD=5+NFQ
      IF(NAT.EQ.4)MLD=5+NTIME
      N3=N2+MLD*NSS
      N4=N3+NST*NTF
      N5=N4+NST*MLD
      N6=N5+5*NTF
      N7=N6+NTF*4
      IF(N7.GT.MTOT) CALL TABR (N7-MTOT)
      CALL TABD (A(N1),A(N2),A(N3),A(N4),A(N5),NSS,NTF,MLD,NST,A(N6))
  300 CALL SECOND (T(5))
C
C     CALCULATE AND PRINT DISPLACEMENTS AND STRESSES
C
      IF (NAT.EQ.1) GO TO 400
      CALL TABP (MTOT)
  400 CALL SECOND (T(6))
      TT=T(6)-T(1)
      DO 500 I=1,5
  500 T(I)=T(I+1)-T(I)
      T(6)=TT
      WRITE (6,2002) T
C
      GO TO 100
C
 1000 FORMAT (7I5,9A5)
 2000 FORMAT (1H1,9A5/
     126H TOTAL NUMBER OF STORIES--I4/
     126H NUMBER OF DIFF. FRAMES---I4/
     126H TOTAL NUMBER OF FRAMES---I4/
     126H NUMBER OF LOAD CONDITIONSI4/
     126H TYPE OF ANALYSIS---------I4/
     126H NUMBER OF FREQUENCIES----I4/
     126H STORY TRANSLATION CODE---I4)
 2001 FORMAT (1H1,9A5/
     126H FRAME ID NUMBER---------- I4/
     126H NUMBER OF COLUMN LINES--- I4/
     126H NUMBER OF STORY LEVELS--- I4/
     126H NUMBER OF DIFF. COL. PROP I4/
     126H NUMBER OF DIFF. BEAM PROP I4/
     126H NUMBER OF DIFF. FEF------ I4/
     126H NUMBER OF PANEL ELEMENTS- I4)
 2002 FORMAT (///19H TIME LOG (SECONDS) //
     1	41H FORM FRAME STIFFNESSES................ = F7.2/
     2	41H SOLVE STATIC LOAD CASES............... = F7.2/
     3	41H MODE SHAPES AND FREQUENCIES........... = F7.2/
     4	41H COMPUTE FRAME DISPLACEMENTS........... = F7.2/
     5	41H COMPUTE AND PRINT STRESSES AND DISPLS. = F7.2//
     6	41H TOTAL TIME............................ = F7.2)
 2003 FORMAT (14H0...FRAME TYPE I3,4H ... /
     1	4X,33HTIME REQUIRED TO FORM STIFFNESS = F6.2)
C
      END
      SUBROUTINE TABR(M)
      WRITE (6,1000) M
      STOP
 1000 FORMAT (20H ** INCREASE MTOT BY I5,3H **)
      END
      SUBROUTINE TABI (SD,PA,PB,NST)
C
      DIMENSION SD(NST,14),PA(NST,2),PB(NST,2)
C
C     READ AND PRINT STORY DATA
C
      WRITE (6,3000)
      DO 200 N=1,NST
      LN=NST+1-N
      READ (5,1000) (SD(N,I),I=1,10),PA(N,1),PA(N,2),SD(N,12),SD(N,13),
     1		    PB(N,1),PB(N,2)
  200 WRITE (6,2000) LN,(SD(N,I),I=1,8)
      WRITE (6,3001)
      DO 300 N=1,NST
      LN=NST+1-N
      SD(N,11)=SD(N,9)*(PA(N,2)-SD(N,6))-SD(N,10)*(PA(N,1)-SD(N,5))
      SD(N,14)=SD(N,12)*(PB(N,2)-SD(N,6))-SD(N,13)*(PB(N,1)-SD(N,5))
  300 WRITE (6,2001) LN,(SD(N,I),I=9,14),PA(N,1),PA(N,2),PB(N,1),PB(N,2)

      RETURN
C
 1000 FORMAT (A5,5X,7F10.0/8F10.0)
 2000 FORMAT (I8,3X,A5,7F13.2)
 2001 FORMAT (I8,6F13.2,3X,4F8.1)
 3000 FORMAT (////11H STORY DATA //  10H LEVEL NO. 3X,2HID 8X,6HHEIGHT
     1 6X,7HMASS(M) 8X,5HMR**2 9X,4HX(M) 9X,4HY(M) 10X,3HK-X 10X,3HK-Y)
 3001 FORMAT (///40H STRUCTURE LATERAL LOADS...CASES A AND B  //
     1 10H LEVEL NO. 7X,4HRX-A 9X,4HRY-A 10X,3HM-A 9X,4HRX-B 9X,4HRY-B
     2 10X,3HM-B 8X,2HXA 6X,2HYA 6X,2HXB 6X,2HYB )

      END

      SUBROUTINE TITLE

       IMPLICIT CHARACTER*60(z)

       WRITE(*,10)
10     FORMAT(1X,' Name of the input file please : ',\)
       READ(*,20)zFILE5


       WRITE(*,30)
30     FORMAT(1X,' Name of the output file please : ',\)
       READ(*,20)zFILE6
20     format(a12)

       OPEN(5,FILE=zFILE5,STATUS='OLD')
       OPEN(6,FILE=zFILE6,STATUS='NEW')

       OPEN(1,FILE='1.TEM',STATUS='NEW',FORM='UNFORMATTED')
       OPEN(2,FILE='2.TEM',STATUS='NEW',FORM='UNFORMATTED')
       OPEN(3,FILE='3.TEM',STATUS='NEW',FORM='UNFORMATTED')

       RETURN

      END
      SUBROUTINE TABF(SD,BW,CP,BP,FEF,LB,LDB,LC,LP,S,R,NST,NB,NC,NCP,
     1 NBP,NS,NFEF,NPAN,IFEF,PP,NN,IF)

      DIMENSION SD(NST,14),BW(NB),CP(5,NCP),BP(5,NBP),FEF(7,NFEF),
     1 LB(NS,NB),LDB(NS,NB,3),LC(NS,NC),LP(2,NPAN),IFEF(NFEF),PP(5,NPAN)
      COMMON /JUNK2/ NLD,N,ND,MM,MN,LM(6),SS(6,6),P(6,3),T(6)
      COMMON /GROUP3/ HI
C     DATA HI /1HI / ******************************************
C
      NLD=3
C
C     READ AND PRINT OF BAY WIDTHS
C
      IF(NB.EQ.0) GO TO 100
      READ  (5,1000) (BW(I),I=1,NB)
      WRITE (6,2000) (BW(I),I=1,NB)
C
C     READ AND PRINT OF COLUMN PROPERTIES
C
  100 L=NCP-1
      READ  (5,1001) (M,(CP(J,I),J=1,5),I=1,L)
      WRITE (6,2001) (I,(CP(J,I),J=1,5),I=1,L)
      DO 110 I=1,5
  110 CP(I,NCP)=0.
C
C     READ AND PRINT OF BEAM PROPERTIES
C
      IF(NB.EQ.0) GO TO 300
      L=NBP-1
      READ  (5,1002) (M,(BP(J,I),J=1,5),I=1,L)
      WRITE (6,2002) (I,(BP(J,I),J=1,5),I=1,L)
      DO 120 I=1,5
  120 BP(I,NBP)=0.
C
C     READ AND PRINT OF FIXED END BEAM LOADS
C
      IF (NFEF.EQ.0) GO TO 208
  205 READ  (5,1003) (M,IFEF(I),(FEF(J,I),J=1,7),I=1,NFEF)
      WRITE (6,2003) (I,IFEF(I),(FEF(J,I),J=1,5),I=1,NFEF)
C
C     READ (OR GENERATE) AND PRINT OF BEAM LOCATION CARDS - LB
C
  208 IF (NB.EQ.0) GO TO 300
  210 WRITE (6,2004)
      DO 260 M=1,NB
      K=0
      DO 250 N=1,NS
      IF (K.NE.0) GO TO 220
      LN=NS+1-N
      READ (5,1004) LB(N,M),K,(LDB(N,M,L),L=1,NLD)
      WRITE(6,1004) LN,M,LB(N,M),K,(LDB(N,M,L),L=1,NLD)
      IF (LB(N,M).EQ.0) LB(N,M)=NBP
      GO TO 250
  220 K=K-1
      LB(N,M)=LB(N-1,M)
      DO 230 L=1,NLD
  230 LDB(N,M,L)=LDB(N-1,M,L)
  250 CONTINUE
  260 WRITE (6,3000)
      WRITE (6,3004)
      CALL TABCBL (LB,NS,NB,1,1,NBP)
      IF (NFEF.EQ.0) GO TO 300
      DO 270 L=1,NLD
      WRITE (6,4004) (HI,I=1,L)
      CALL TABCBL (LDB,NS,NB,3,L,100000)
  270 CONTINUE
C
C     READ (OR GENERATE) AND PRINT COLUMN LOCATIONS - LC
C
  300 WRITE (6,2005)
      DO 360 M=1,NC
      K=0
      DO 350 N=1,NS
      IF (K.NE.0) GO TO 320
      LN=NS+1-N
      READ  (5,1005) LC(N,M),K
      WRITE (6,1005) LN,M,LC(N,M),K
      IF(LC(N,M).EQ.0) LC(N,M)=NCP
      GO TO 350
  320 K=K-1
      LC(N,M)=LC(N-1,M)
  350 CONTINUE
  360 WRITE (6,3000)
      WRITE (6,3005)
      CALL TABCBL (LC,NS,NC,1,1,NCP)
C
C     READ AND PRINT OF PANEL CARDS - LP,PP
C
      IF(NPAN.EQ.0) GO TO 380
      READ  (5,1006) (LP(1,I),LP(2,I),(PP(J,I),J=1,5),I=1,NPAN)
      WRITE (6,2006) (LP(1,I),LP(2,I),(PP(J,I),J=1,5),I=1,NPAN)
C
C     STORY BY STORY FORMATION AND REDUCTION OF STIFFNESS MATRIX
C
  380 K=NST-NS
      MM=2*NC
      MN=4*NC
      NN=MN+NS+1
      CALL TABX(1,S,R,NN)
C
      DO 700 N=1,NS
C
      CALL TABX(2,S,R,NN)
C
C      1. FORM COLUMN MATRICES
C
      DO 395 I=1,6
      DO 390 L=1,NLD
  390 P(I,L)=0.0
      DO 395 J=1,6
  395 SS(I,J)=0.0
      ND=6
      DO 500 M=1,NC
      MC=LC(N,M)
      IF(MC.EQ.NCP) GO TO 500
      A=0.0
      XL =SD(N+K,2)
      IF (NB.EQ.0) GO TO 420
      MR=LB(N,M)
      IF (M.EQ.1) GO TO 400
      ML=LB(N,M-1)
      IF (M.EQ.NC) GO TO 410
      A=(BP(5,ML)+BP(5,MR))/2.
      GO TO 420
  400 A=BP(5,MR)
      GO TO 420
  410 A=BP(5,ML)
  420 XL=XL-A
      BB=0.0
      IF ( CP(4,MC) ) 430,430,425
  425 BB=14.4*CP(3,MC)/(XL**2*CP(4,MC))
  430 COMM=2.*CP(1,MC)*CP(3,MC)/(XL*(1.+2.*BB))
      SA=COMM*(2.+BB)
      SB=COMM*(1.-BB)
      SC=CP(2,MC)*CP(1,MC)/XL
      CALL TABY(SA,SB,SC,XL,A,0.0)
      LM(3)=2*M
      LM(1)=LM(3)+MM
      LM(5)=LM(1)-1
      LM(6)=LM(3)-1
      LM(4)=MN+N
      LM(2)=LM(4)+1
      CALL TABX(5,S,R,NN)
  500 CONTINUE
C
C      2. FORM BEAM MATRICES
C
      IF (NB.EQ.0) GO TO 610
      ND=4
      DO 600 M=1,NB
      MB=LB(N,M)
      IF(MB.EQ.NBP) GO TO 600
      ML=LC(N,M)
      MR=LC(N,M+1)
      A=CP(5,MR)/2.
      B=CP(5,ML)/2.
      XL=BW(M)-A-B
      EIOL=BP(1,MB)*BP(2,MB)/XL
      SA=BP(3,MB)*EIOL
      SB=BP(4,MB)*SA
      CALL TABY(SA,SB,0.0,XL,A,B)
      LM(1)=2*M
      LM(2)=LM(1)-1
      LM(3)=LM(1)+2
      LM(4)=LM(3)-1
      DO 550 L=1,NLD
      DO 520 I=1,4
  520 P(I,L)=0.
      J=LDB(N,M,L)
      IF (J) 550,550,530
  530 V=FEF(5,J)*XL/2.
      YM=V*XL/6.
      P(1,L)=FEF(1,J)+YM
      P(2,L)=FEF(2,J)+V
      P(3,L)=-FEF(3,J)-YM
      P(4,L)=FEF(4,J)+V
      IF(IFEF(J)) 550,540,550
  540 P(1,L)=P(1,L)+P(2,L)*B
      P(3,L)=P(3,L)-P(4,L)*A
  550 CONTINUE
      CALL TABX(5,S,R,NN)
  600 CONTINUE
C
C     FORM PANEL STIFFNESS
C
      IF(NPAN.EQ.0) GO TO 610
      DO 720 I=1,6
      DO 720 J=1,3
  720 P(I,J)=0.
      ND=6
      DO 800 L=1,NPAN
      NP=NS-LP(1,L)+1
      IF(NP.NE.N) GO TO 800
      M=LP(2,L)
      XL=SD(N+K,2)
      D=BW(M)
      BB=XL**2*PP(4,L)*PP(5,L)
      IF (BB) 730,730,725
  725 BB=6.0*PP(1,L)*PP(3,L)/BB
  730 COMM=2.0*PP(1,L)*PP(3,L)/(XL*(1.+2.*BB))
      SA=COMM*(2.+BB)
      SB=COMM*(1.-BB)
      SC=PP(1,L)*PP(2,L)/XL
      CALL TABPN (1,SA,SB,SC,XL,D,SS,CA,T)
      LM(2)=MN+N
      LM(1)=LM(2)+1
      LM(5)=2*M-1
      LM(6)=LM(5)+2
      LM(3)=LM(5)+MM
      LM(4)=LM(6)+MM
      CALL TABX (5,S,R,NN)
  800 CONTINUE
C
C      REDUCE STIFFNESS MATRIX FOR LEVEL N
C
  610 CONTINUE
      CALL TABX(3,S,R,NN)
C
  700 CONTINUE
C
C     WRITE LATERAL STIFFNESS ON TAPE
C
  810 N=NST+1-NS
      CALL TABX(4,S,R,NN)
      WRITE (3) BW,CP,BP,FEF,LB,LDB,LC,LP,IFEF,PP
      WRITE (3) IF,NC,NS,NCP,NBP,NFEF,NPAN
C
      RETURN
 1000 FORMAT (8F10.0)
 2000 FORMAT (11H0BAY WIDTHS/(8F15.3))
 1001 FORMAT (I5,F15.0,4F10.0)
 2001 FORMAT (10H0COLUMN ID  11X,1HE 11X,1HA 11X,1HI 10X,2HSA 11X,1HW/
     1 (I10,5F12.2))
 1002 FORMAT (I5,F15.0,4F10.0)
 2002 FORMAT (10H0  BEAM ID 11X,1HE 11X,1HI 11X,1HK 11X,1HC 11X,1HD/
     1 (I10,5F12.2))
 1003 FORMAT (2I5,7F10.0)
 2003 FORMAT (10H0   FEF ID 6X,4HCODE 10X,2HML 10X,2HVL 10X,2HMR 10X,
     1 2HVR,11X,1HW  /(2I10,5F12.3))
 1004 FORMAT (9I5)
 2004 FORMAT (15H0BEAM LOCATIONS/35H0 LEVEL  M	BID  GEN  VL1  VL2  VL3
     1		   )
 3004 FORMAT (//25H GENERATED BEAM LOCATIONS )
 4004 FORMAT (//34H GENERATED BEAM LOADS...LOAD CASE  3A1)
 1005 FORMAT (4I5)
 2005 FORMAT (17H0COLUMN LOCATIONS/ 20H0 LEVEL	M  CID	GEN
     1		   )
 3005 FORMAT (//27H GENERATED COLUMN LOCATIONS )
 1006 FORMAT (2I5,5F10.0)
 2006 FORMAT (///12H PANEL CARDS //' LEVEL      M'16X,1HE 14X,1HA 14X,
     1	1HI  13X,2HSA  14X,1HG / (I4,I7,2X,5F15.2)
     2			)
 3000 FORMAT (1H )
      END
      SUBROUTINE TABX(IO,S,R,NN)

      DIMENSION S(NN,NN),R(NN,1)
      COMMON /JUNK3/ NLD,N,ND,MM,MN,LM(6),SS(6,6),P(6,3)
C
      GO TO (1,2,3,4,5),IO
C
C     IO=1 ZERO MATRICES
C
    1 DO 200 I=1,NN
      DO 190 L=1,NLD
  190 R(I,L)=0.0
      DO 200 J=1,NN
  200 S(I,J)=0.0
      GO TO 800
C
C     IO=2 SHIFT STORAGE
C
    2 DO 220 I=1,MM
      II=MM+I
      DO 210 J=1,MM
      JJ=MM+J
      S(I,J)=S(II,JJ)
      S(II,JJ)=0.0
  210 S(I,JJ)=0.0
      DO 215 L=1,NLD
      R(I,L)=R(II,L)
  215 R(II,L)=0.0
      JL=MN+1
      DO 220 J=JL,NN
      S(I,J)=S(II,J)
  220 S(II,J)=0.0
      GO TO 800
C
C     IO=3 REDUCE MATRIX AND WRITE B.S. EQUATIONS ON TAPE 3
C
    3 NNN=MN+N+1
      DO 345 I=1,MM
      IF (S(I,I)) 345,345,305
C
  305 DO 320 L=1,NLD
  320 R(I,L)=R(I,L)/S(I,I)
C
      JJ=I+1
      DO 310 J=JJ,NNN
      S(J,I)=S(I,J)
  310 S(I,J)=S(I,J)/S(I,I)
C
      DO 340 K=JJ,NNN
      DO 330 J=K,NNN
  330 S(K,J)=S(K,J)-S(K,I)*S(I,J)
      DO 340 L=1,NLD
  340 R(K,L)=R(K,L)-S(K,I)*R(I,L)
  345 CONTINUE
C
      DO 346 I=1,MM
346   WRITE (3) (S(I,J),J=1,NN)
      DO 347 I=1,MM
347   WRITE (3) (R(I,L),L=1,NLD)
      GO TO 800
C
C     IO=4 WRITE LATERAL STIFFNESS MATRIX ON TAPE 2
C
    4 IL=MN+1
      IH=NN-1
      NS=NN-MN-1
      LRD=((NS+1)*NS)/2
      WRITE (2) LRD,N ,((S(I,J),J=I,IH),I=IL,IH),((R(I,L),I=IL,IH),
     1		L=1,NLD)
      GO TO 800
C
C     IO=5 ADD ELEMENT STIFFNESS TO TOTAL STIFFNESS
C
    5 DO 550 I=1,ND
      II=LM(I)
      DO 510 L=1,NLD
  510 R(II,L)=R(II,L)+P(I,L)
      DO 550 J=1,ND
      JJ=LM(J)
  550 S(II,JJ)=S(II,JJ)+SS(I,J)
      GO TO 800
C
  800 RETURN
C
      END

      SUBROUTINE TABY(SA,SB,SC,XL,A,B)

      COMMON /JUNK4/ NLD,N,ND,MM,MN,LM(6),SS(6,6),P(6,3),T(2,4)

C
C     FORM BEAM OR COLUMN STIFFNESS
C
      T(2,1)=B/XL
      T(1,1)=1.0+T(2,1)
      T(1,2)=1.0/XL
      T(2,2)=T(1,2)
      T(1,3)=A/XL
      T(2,3)=1.0+T(1,3)
      T(1,4)=-T(1,2)
      T(2,4)=T(1,4)
C
      DO 100 I=1,4
      D1=SA*T(1,I)+SB*T(2,I)
      D2=SB*T(1,I)+SA*T(2,I)
      DO 100 J=1,4
  100 SS(J,I)=D1*T(1,J)+D2*T(2,J)
C
C
  110 SS(5,5)=SC
      SS(5,6)=-SC
      SS(6,5)=-SC
      SS(6,6)=SC
C
  120 RETURN
C
      END
      SUBROUTINE TABPN (IO,SA,SB,SC,XL,D,SS,CA,T)
C
      DIMENSION SS(6,6),CA(4,6),T(3,6)
C
C     PANEL STIFFNESS AND FORCE MATRICES
C
      DO 10 I=1,3
      DO 10 J=1,6
   10 T(I,J)=0.0
C
      T(1,1)=1.0/XL
      T(2,1)=T(1,1)
      T(1,2)=-T(1,1)
      T(2,2)=-T(1,1)
C
      T(1,4)=1.0/D
      T(2,6)= T(1,4)
      T(1,3)=-T(1,4)
      T(2,5)=-T(1,4)
C
      T(3,3)= 0.5
      T(3,4)= 0.5
      T(3,5)=-0.5
      T(3,6)=-0.5
C
      GO TO (100,200),IO
C
C      STIFFNESS SS (IO=1)
  100 DO 120 J=1,6
      U=SA*T(1,J)+SB*T(2,J)
      V=SB*T(1,J)+SA*T(2,J)
      W=SC*T(3,J)
      DO 120 I=1,6
  120 SS(I,J)=U*T(1,I)+V*T(2,I)+W*T(3,I)
      RETURN
C
C      FORCE MATRIX CA	(IO=2)
  200 DO 220 I=1,6
      CA(1,I)=SA*T(1,I)+SB*T(2,I)
      CA(2,I)=SB*T(1,I)+SA*T(2,I)
      CA(3,I)=SC*T(3,I)
  220 CA(4,I)=-(CA(1,I)+CA(2,I))/XL
      RETURN
C
      END
      SUBROUTINE TABCBL (LBC,NS,NR,NL,L,NPROP)
      COMMON /JUNK5/ NLD,LOC(30)
      DIMENSION LBC(NS,NR,NL)
C
C     PRINT MEMBER LOCATIONS AS GENERATED
C
      DO 200 J=1,NR,30
      JJ=J+29
      IF (JJ.GT.NR) JJ=NR
      WRITE (6,2000) (I,I=J,JJ)
      WRITE (6,2002)
      DO 200 I=1,NS
      DO 100 K=J,JJ
      LOC(K)=LBC(I,K,L)
      IF (LOC(K).EQ.NPROP) LOC(K)=0
  100 CONTINUE
      M=NS+1-I
  200 WRITE (6,2001) M,(LOC(K),K=J,JJ)
C
      RETURN
 2000 FORMAT (6H0STORY 30I4)
 2001 FORMAT (I4,2X,30I4)
 2002 FORMAT (1H )
      END

      SUBROUTINE TABL (A,SS,RR,S,R,D,AA,MSS,MST,MTF,HED)

      DIMENSION SS(MSS,MSS),RR(MSS,5),A(MST,14),S(1),R(MST,3)
     1		,D(MST,MTF),AA(MTF,5),HED(MTF,4)
      COMMON/GEN/ NST,NDF,NTF,NLD,NAT,NFQ,NSD,BHED(9),FHED(9),NSS,I3,IS
     1		  ,RLAB(3)
      COMMON /JUNK6/AI(3),AJ(3)
C
C     COMPUTE STRUCTURE LATERAL STIFFNESS , SOLVE STATIC LOAD CASES
C
      REWIND 2
      DO 50 I=1,NSS
      DO 40 J=1,3
   40 RR(I,J)=0.
      DO 50 J=1,NSS
   50 SS(I,J)=0.
      DO 100 I=1,NST
      II=I3*(I-1)
      SS(II+1,II+1)=A(I,7+IS)
      IF(NSD.EQ.0) SS(II+2,II+2)=A(I,8)
      DO 100 J=1,I3
      DO 100 L=1,2
      LL=5+3*L+J+IS
  100 RR(II+J,L+3)=A(I,LL)
C
      WRITE (6,3000)
      IFP=0
      DO 500 K=1,NTF
      READ  (5,1000) IF,IFC,X1,Y1,X2,Y2,(HED(K,J),J=1,4)
      WRITE (6,2000) K,IF,IFC,X1,Y1,X2,Y2,(HED(K,J),J=1,4)
      IF(IF.EQ.IFP) GO TO 150
      READ (2) LRD,NT,(S(I),I=1,LRD),((R(I,L),I=NT,NST),L=1,3)
      IFP=IF
  150 YY=Y1-Y2
      XL=SQRT((X2-X1)*(X2-X1)+YY*YY)
      DO 200 N=NT,NST
      AR=X1*(Y2-A(N,6))+X2*(A(N,6)-Y1)+A(N,5)*YY
  200 D(N,K)=AR/XL
C
      AI(1)=(X2-X1)/XL
      AI(2)=(Y2-Y1)/XL
      AJ(2)=AI(2)
      AJ(1)=AI(1)
C
      KK=0
      DO 400 N=NT,NST
      AI(3)=-D(N,K)
      NN=I3*(N-1)
      DO 300 L=1,3
      DO 300 I=1,I3
  300 RR(NN+I,L)=RR(NN+I,L)+R(N,L)*AI(I+IS)
      DO 400 M=N,NST
      MM=I3*(M-1)
      AJ(3)=-D(M,K)
      KK=KK+1
      DO 400 I=1,I3
      DO 400 J=1,I3
  400 SS(NN+I,MM+J)=SS(NN+I,MM+J)+S(KK)*AI(I+IS)*AJ(J+IS)
C
      AA(K,1)=IF
      AA(K,2)=IFC
      AA(K,3)=AI(1)
      AA(K,4)=AI(2)
      AA(K,5)=NT
  500 CONTINUE
C
      DO 600 I=1,NSS
      DO 600 J=I,NSS
  600 SS(J,I)=SS(I,J)
      REWIND 2
      WRITE (2) SS
      IF(NAT.EQ.1) RETURN
      CALL TABQ (SS,NSS,RR,5)
C
C     PRINT STRUCTURE DISPLACEMENTS
C
      WRITE (6,2001)
      DO 700 I=1,NST
      LN=NST+1-I
      WRITE (6,2003)
      DO 700 J=1,I3
      II=I3*(I-1)+J
  700 WRITE (6,2002) LN,A(I,1),RLAB(J+IS),(RR(II,L),L=1,5)
C
      WRITE (2) RR
      WRITE (2) AA,D,HED
C
      RETURN
 1000 FORMAT (2I5,4F10.0,6A5)
 2000 FORMAT (I4,I6,I9,6X,  4F12.3,10X,6A5)
 2001 FORMAT (	 24H1STRUCTURE DISPLACEMENTS ,30X,10HLOAD CASES  //
     1	18H LEVEL   ID	 DIRN 10X,1HI 11X,2HII 10X,3HIII 12X,1HA 12X,
     1	1HB )
 2002 FORMAT (I4,3X,A5,2X,A4,3X,5F13.6)
 2003 FORMAT (1H )
 3000 FORMAT (	   20H1FRAME POSITION DATA //
     1	23H FRAME   ID	FORCE CODE 10X,2HX1 10X,2HY1 10X,2HX2 10X,2HY2 )
      END
