
      SUBROUTINE TABQ (A,N,B,NL)
C
C     SOLUTION OF SYMMETRICAL LINEAR EQUATIONS- E L WILSON
C
      DIMENSION A(N,N),B(N,NL)
C
      M=0
C
C     REDUCTION OF M TH EQUATION
C
   50 M=M+1
      MM=M+1
      DO 60 L=1,NL
   60 B(M,L)=B(M,L)/A(M,M)
      IF (M-N) 70,130,70
   70 DO 80 J=MM,N
   80 A(M,J)=A(M,J)/A(M,M)
C
C     SUBSTITUTION INTO REMAINING EQUATIONS
C
      DO 120 I=MM,N
      IF (A(I,M)) 90,120,90
   90 DO 100 J=I,N
      A(I,J)=A(I,J)-A(I,M)*A(M,J)
  100 A(J,I)=A(I,J)
      DO 110 L=1,NL
  110 B(I,L)=B(I,L)-A(I,M)*B(M,L)
  120 CONTINUE
      GO TO 50
C
C     BACK SUBSTITUTION
C
  130 M=M-1
      IF (M.EQ.0) GO TO 150
      MM=M+1
      DO 140 L=1,NL
      DO 140 J=MM,N
  140 B(M,L)=B(M,L)-A(M,J)*B(J,L)
      GO TO 130
C
  150 RETURN

      END

      SUBROUTINE TABE (A,F,XM,W,IQ,S,PA,MSS,MST)

      DIMENSION F(MSS,MSS),S(MSS,MSS),XM(1),W(1),IQ(1),A(MST,4),PA(2,1)
      COMMON/GEN/ NST,NDF,NTF,NLD,NAT,NFQ,NSD,BHED(9),FHED(9),NSS,I3,IS
     1		  ,RLAB(3)
      COMMON /JUNK7/ SC(2),SHED(10)
      COMMON /DYN1/ NTIME,DT,NPC,DAMP
C
C     COMPUTE MODE SHAPES AND FREQUENCIES
C
      REWIND 2
      TPI=8.0*ATAN(1.0)
      READ (2) S
      IF (NAT.EQ.0) GO TO 700
      DO 100 I=1,NST
      II=I3*(I-1)+1
      XM(II  )=A(I,3)
      XM(II+1)=A(I,3)
  100 XM(II+2)=A(I,4)
C
      DO 150 I=1,NSS
      IF(XM(I).GT.0.) GO TO 150
      WRITE (6,3002)
      STOP
  150 XM(I)=1.0/SQRT(XM(I))
      DO 200 I=1,NSS
      DO 200 J=1,NSS
  200 S(I,J)=S(I,J)*XM(I)*XM(J)
C
      CALL TABH (S,NSS,0,F,NR,W,IQ)
C
      DO 250 I=1,NSS
      W(I)=S(I,I)
      DO 250 J=1,NSS
  250 F(I,J)=F(I,J)*XM(I)
      DO 300 I=1,NFQ
      WM=W(I)
      DO 270 J=I,NSS
      IF(W(J).GT.WM) GO TO 270
      WM=W(J)
      K=J
  270 CONTINUE
C
      W(K)=W(I)
      W(I)=TPI/SQRT(WM)
      DO 300 J=1,NSS
      WM=F(J,K)
      F(J,K)=F(J,I)
  300 F(J,I)=WM
C     PRINT MODES,PERIODS
  520 WRITE (6,2001) (I,W(I),I=1,NFQ)
      DO 600 I=1,NFQ,8
      IH=I+7
      IF(IH.GT.NFQ) IH=NFQ
      WRITE (6,2003) (J,J=I,IH)
      DO 600 N=1,NST
      LN=NST+1-N
      NN=I3*(N-1)
      WRITE (6,2002)
      DO 600 J=1,I3
  600 WRITE (6,2004) LN,A(N,1),RLAB(J+IS),( F(NN+J,K),K=I,IH)
      IF(NAT.EQ.1) RETURN
C
C     DYNAMIC ANALYSIS
C
      IF(NAT.NE.4) GO TO 440
C
C     GROUND MOTION CONTROL DATA
      READ (5,1001) NPC,NTIME,SF,FI,DT,SHED
      WRITE(6,2005)SHED,NPC,NTIME,SF,FI,DT
      GO TO 445
C
  440 IF(NAT.NE.3) GO TO 700
C
C     RESPONSE SPECTRUM DATA
      READ  (5,1000) NPC,SF,FI,SHED,(PA(1,I),PA(2,I),I=1,NPC)
      WRITE (6,2000) SHED,NPC,SF,FI,(PA(1,I),PA(2,I),I=1,NPC)
C
C     MODAL PARTICIPATION FACTORS
C
  445 FI=FI*ATAN(1.0)/45.
      SC(1)=SIN(FI)
      SC(2)=COS(FI)
      DO 500 I=1,NFQ
      RLM=0.
      DO 450 J=1,NST
      JJ=I3*(J-1)+1
      FR=F(JJ,I)*SC(1+IS)
      IF(NSD.EQ.0) FR=FR+F(JJ+1,I)*SC(2)
  450 RLM=RLM+FR*A(J,3)
      WW=(TPI/W(I))**2
      IF (NAT.EQ.3) YM=RLM*TABA(NPC,SF,W(I),PA)/WW
      IF (NAT.EQ.4) YM=RLM*SF
      DO 500 J=1,NSS
  500 F(J,I)=F(J,I)*YM
C
C     SAVE MODE SHAPES ON TAPE 1   NAT=4
C
      IF(NAT.NE.4) GO TO 550
      REWIND 1
      WRITE(6,3000)
      DO 800 K=1,NFQ
      READ (5,1002) I,DAMP
      IF(DAMP.LE.1.0) GO TO 720
      DAMP=1.0
      WRITE (6,3001) I
  720 WRITE (6,2006) I,DAMP
      WRITE (1) W(K),DAMP,(F(I,K),I=1,NSS)
  800 CONTINUE
C
  550 DO 650 K=1,NFQ
      I=NFQ+1-K
      DO 650 J=1,NSS
  650 F(J,I+5)=F(J,I)
C
  700 READ (2) ((F(I,J),I=1,NSS),J=1,5)
C
      RETURN
C
 1000 FORMAT (I5,F15.0,F10.0,10A5/(2F10.0))
 1001 FORMAT (2I5,3F10.0,10A4)
 1002 FORMAT (I5,F10.2)
 2000 FORMAT (	  22H1ACCELERATION SPECTRUM ,5X,10A5,/
     1 25H NUMBER OF PERIOD CARDS =   I8/
     2 25H SCALE FACTOR 	  =   F10.3/
     3 25H ANGLE OF EQ INCIDENCE  =   F10.3,/
     4 26H  PERIOD	ACCELERATION ,/,(F10.3,5X,F10.3)
 2001 FORMAT (	  22H1MODE NUMBER    PERIOD  //(I7,6X,F11.6))
 2002 FORMAT (1H )
 2003 FORMAT (/// 12H MODE SHAPES/ /18H LEVEL  ID    DIRN ,8I13)
 2004 FORMAT (I5,2X,A5,2X,A4,2X,8F13.6)
 2005 FORMAT (23H1RESPONSE ANALYSIS DATA  ///
     . 31H ACCELERATION HISTORY HEADING..  10A4//
     1 30H NUMBER OF ACCELERATION CARDS        I3 /
     2 30H NUMBER OF OUTPUT TIMES	       I3 /
     3 30H ACCELERATION SCALE FACTOR	       F10.4/
     4 30H ANGLE OF EQ INCIDENCE	       F10.4/
     5 30H TIME INCREMENT FOR OUTPUT	       F10.4/
     6		  )
 2006 FORMAT(I4,F12.3)
 3000 FORMAT( /// 16H MODE    DAMPING )
 3001 FORMAT (30H DAMPING MUST BE LESS THAN 1.0 /
     1	15H VALUE FOR MODE  I3, 6H RESET )
 3002 FORMAT (/// 22H NEGATIVE OR ZERO MASS //21H EXECUTION TERMINATED)
      END
      FUNCTION	 TABA (NPC,SF,T,PA)
      DIMENSION PA(2,NPC)
C
C     SPECTRUM INTERPOLATION
C
      DO 100 I=2,NPC
      T1=PA(1,I-1)
      T2=PA(1,I  )
      IF(T.LE.T2) GO TO 200
  100 CONTINUE
  200 R1=(T2-T)/(T2-T1)
      R2=(T-T1)/(T2-T1)
      TABA=SF*(PA(2,I-1)*R1+PA(2,I)*R2)
      RETURN
      END
      SUBROUTINE TABH (H,N,IEGEN,U,NR,X,IQ)
C
      DIMENSION H(N,N),U(N,N),X(N),IQ(N)
C
      IF (IEGEN) 15,10,15
 10   DO 14 I=1,N
      DO 14 J=1,N
      IF(I-J) 12,11,12
 11   U(I,J)=1.0
      GO TO 14
 12   U(I,J)=0.
 14   CONTINUE
C
 15   NR = 0
      IF (N-1) 1000,1000,17
C
C     SCAN FOR LARGEST OFF DIAGONAL ELEMENT IN EACH ROW
C     X(I) CONTAINS LARGEST ELEMENT IN ITH ROW
C     IQ(I) HOLDS SECOND SUBSCRIPT DEFINING POSITION OF ELEMENT
C
 17   NMI1=N-1
      DO 30 I=1,NMI1
      X(I) = 0.
      IPL1=I+1
      DO 30 J=IPL1,N
      IF ( X(I) - ABS( H(I,J))) 20,20,30
 20   X(I)=ABS(H(I,J))
      IQ(I)=J
 30   CONTINUE
C
C     SET INDICATOR FOR SHUT-OFF.RAP=2**-27,NR=NO. OF ROTATIONS
      RAP=7.450580596E-9
      HDTEST=1.0E38
C
C     FIND MAXIMUM OF X(I) S FOR PIVOT ELEMENT AND
C     TEST FOR END OF PROBLEM
C
 40   DO  70  I=1,NMI1
      IF (I-1) 60,60,45
 45   IF ( XMAX- X(I)) 60,70,70
 60   XMAX=X(I)
      IPIV=I
      JPIV=IQ(I)
 70   CONTINUE
C
C     IS MAX. X(I) EQUAL TO ZERO, IF LESS THAN HDTEST, REVISE HDTEST
      IF ( XMAX) 1000,1000,80
 80   IF (HDTEST) 90,90,85
 85   IF (XMAX - HDTEST) 90,90,148
 90   HDIMIN = ABS( H(1,1) )
      DO 110  I= 2,N
      IF (HDIMIN- ABS( H(I,I))) 110,110,100
 100  HDIMIN=ABS(H(I,I))
 110  CONTINUE
C
      HDTEST=HDIMIN*RAP
C
C     RETURN IF MAX.H(I,J)LESS THAN(2**-27)ABSF(H(K,K)-MIN)
      IF (HDTEST- XMAX) 148,1000,1000
 148  NR = NR+1
C
C     COMPUTE TANGENT, SINE AND COSINE,H(I,I),H(J,J)
 150  TANG=SIGN(2.0,(H(IPIV,IPIV)-H(JPIV,JPIV)))*H(IPIV,JPIV)/(ABS(H(I
     1PIV,IPIV)-H(JPIV,JPIV))+SQRT((H(IPIV,IPIV)-H(JPIV,JPIV))**2+4.0*H
     2(IPIV,JPIV)**2))
      COSINE=1.0/SQRT(1.0+TANG**2)
      SINE=TANG*COSINE
      HII=H(IPIV,IPIV)
      H(IPIV,IPIV)=COSINE**2*(HII+TANG*(2.*H(IPIV,JPIV)+TANG*H(JPIV,JPIV
     1)))
      H(JPIV,JPIV)=COSINE**2*(H(JPIV,JPIV)-TANG*(2.*H(IPIV,JPIV)-TANG*H
     1II))
      H(IPIV,JPIV)=0.
C
C      PSEUDO RANK THE EIGENVALUES
C      ADJUST SINE AND COS FOR COMPUTATION OF H(IK) AND U(IK)
      IF ( H(IPIV,IPIV) -  H(JPIV,JPIV)) 152,153,153
 152  HTEMP = H(IPIV,IPIV)
      H(IPIV,IPIV) = H(JPIV,JPIV)
      H(JPIV,JPIV) = HTEMP
C	RECOMPUTE SINE AND COS
      HTEMP = SIGN (1.0, -SINE) * COSINE
      COSINE = ABS (SINE)
      SINE = HTEMP
 153  CONTINUE
C
C     INSPECT THE IQS BETWEEN I+1 AND N-1 TO DETERMINE
C     WHETHER A NEW MAXIMUM VALUE SHOULD BE COMPUTED SINCE
C     THE PRESENT MAXIMUM IS IN THE I OR J ROW.
C
      DO 350 I=1,NMI1
      IF(I-IPIV)210,350,200
 200  IF(I-JPIV)210,350,210
 210  IF(IQ(I)-IPIV)230,240,230
 230  IF(IQ(I)-JPIV)350,240,350
 240  K=IQ(I)
 250  HTEMP=H(I,K)
      H(I,K)=0.
      IPL1=I+1
      X(I) =0.
C
C     SEARCH IN DEPLETED ROW FOR NEW MAXIMUM
C
      DO 320 J=IPL1,N
      IF ( X(I)- ABS( H(I,J)) ) 300,300,320
 300  X(I) = ABS(H(I,J))
      IQ(I)=J
 320  CONTINUE
      H(I,K)=HTEMP
 350  CONTINUE
C
      X(IPIV) =0.
      X(JPIV) =0.
C
C     CHANGE THE OTHER ELEMENTS OF H
C
      DO 530 I=1,N
C
      IF(I-IPIV)370,530,420
 370  HTEMP = H(I,IPIV)
      H(I,IPIV) = COSINE*HTEMP + SINE*H(I,JPIV)
      IF ( X(I) -  ABS( H(I,IPIV)) )380,390,390
 380  X(I) = ABS(H(I,IPIV))
      IQ(I) = IPIV
 390  H(I,JPIV) = -SINE*HTEMP + COSINE*H(I,JPIV)
      IF ( X(I) -  ABS( H(I,JPIV)) ) 400,530,530
 400  X(I) = ABS(H(I,JPIV))
      IQ(I) = JPIV
      GO TO 530
C
 420  IF(I-JPIV)430,530,480
 430  HTEMP = H(IPIV,I)
      H(IPIV,I) = COSINE*HTEMP + SINE*H(I,JPIV)
      IF ( X(IPIV) -  ABS( H(IPIV,I)) ) 440,450,450
 440  X(IPIV) = ABS(H(IPIV,I))
      IQ(IPIV) = I
 450  H(I,JPIV) = -SINE*HTEMP + COSINE*H(I,JPIV)
      IF ( X(I) -  ABS( H(I,JPIV)) ) 400,530,530
C
 480  HTEMP = H(IPIV,I)
      H(IPIV,I) = COSINE*HTEMP + SINE*H(JPIV,I)
      IF ( X(IPIV) -  ABS( H(IPIV,I)) ) 490,500,500
 490  X(IPIV) = ABS(H(IPIV,I))
      IQ(IPIV) = I
 500  H(JPIV,I) = -SINE*HTEMP + COSINE*H(JPIV,I)
      IF ( X(JPIV) -  ABS( H(JPIV,I)) ) 510,530,530
 510  X(JPIV) = ABS(H(JPIV,I))
      IQ(JPIV) = I
 530  CONTINUE
C
C     TEST FOR COMPUTATION OF EIGENVECTORS
C
      IF(IEGEN)40,540,40
 540  DO 550 I=1,N
      HTEMP=U(I,IPIV)
      U(I,IPIV)=COSINE*HTEMP+SINE*U(I,JPIV)
 550  U(I,JPIV)=-SINE*HTEMP+COSINE*U(I,JPIV)
      GO TO 40
 1000 RETURN
      END
      SUBROUTINE TABDY(F,PA,X,T,MSS)
C     EVALUATION OF 3D TIME-DEPENDENT LATERAL DISPLACEMENTS
      DIMENSION F(MSS,1),PA(2,1),X(1),T(1)
      COMMON/GEN/ NST,NDF,NTF,NLD,NAT,NFQ,NSD,BHED(9),FHED(9),NSS,I3,IS
     1		  ,RLAB(3)
      COMMON /DYN1/ NTIME,DT,NPC,DAMP
C     ZERO DISPLACEMENTS AND READ GROUND ACCELERATIONS
      DO 100 I=1,MSS
      DO 100 K=1,NTIME
  100 F(I,K+5)=0.0
      READ (5,1000) (PA(1,I),PA(2,I),I=1,NPC)
      WRITE(6,2000) (PA(1,I),PA(2,I),I=1,NPC)
C
C     CHECK GROUND ACCELERATION DATA
C
      DO 120 I=2,NPC
      IF (PA(1,I).GT.PA(1,I-1)) GO TO 120
      WRITE (6,3001) PA(1,I-1),PA(1,I)
      STOP
  120 CONTINUE
      TIME=NTIME
      TIME=TIME*DT
      ATIME=PA(1,NPC)-PA(1,1)
      IF(ATIME.GE.TIME) GO TO 150
      WRITE (6,3000)
      STOP
C
C     FOR EACH MODE CALCULATE RESPONSE AND TOTAL DISPLACEMENTS
C
  150 REWIND 1
      DO 300 L=1,NFQ
      READ (1) W,DAMP,(T(K),K=1,MSS)
      CALL TABRI (PA,X,W,NTIME,NPC,DT,DAMP)
      DO 200 I=1,MSS
      DO 200 J=1,NTIME
  200 F(I,J+5)=F(I,J+5)+T(I)*X(J)
  300 CONTINUE
C
      RETURN
 1000 FORMAT(2F10.0)
 2000 FORMAT (///26H GROUND ACCELERATION CARDS //
     1	       11X,4HTIME,3X,12HACCELERATION  /(2F15.4))
 3000 FORMAT (44H1GROUND ACCELERATION TIME SPAN IS LESS THAN
     1 32HSPECIFIED BUILDING RESPONSE TIME  )
 3001 FORMAT (32H0 INCONSISTENT ACCELERATION DATA //
     1 34H  TIMES MUST INCREASE SEQUENTIALLY //
     2 16H  ERROR AT TIMES  F12.5/16X,F12.6)
      END
      SUBROUTINE TABRI(PA,X,PERD,NTIME,NPC,DDT,DAMP)
      DIMENSION PA(2,1),X(1)
C
C     EVALUATION OF MODAL RESPONSE ... USING EXPLICIT INTEGRATION
C
      W=8.0*ATAN(1.0)/PERD
      WW=W*W
      ZW=DAMP*W
      TZW=2.*ZW
      WD=W*SQRT(1.0-DAMP**2)
      FB=TZW/(WW*WW)
      FA=ZW/WW
      FV=ZW*WW
      FVD=WW*(2.*DAMP**2-1.0)
      FBB=(2.*DAMP**2-1.0)/WW
C
      L=0
      II=1
      VO=0.
      VDO=0.
      TO=PA(1,1)
   10 DT=DDT
   50 B=(PA(2,II+1)-PA(2,II))/(PA(1,II+1)-PA(1,II))
      A=PA(2,II)+B*(TO-PA(1,II))
      TT=TO+DT
      IF(PA(1,II+1).GT.TT) GO TO 100
      DELT=PA(1,II+1)-TO
      GO TO 200
  100 DELT=DT
C
  200 EX=EXP(-ZW*DELT)
      FT=WD*DELT
      CS=COS(FT)
      SN=SIN(FT)
      VT=(VDO+ZW*VO-FA*A+FBB*B)*SN/WD
      VT=VT+(VO-A/WW+FB*B)*CS
      VT=VT*EX+A/WW-FB*B+B*DELT/WW
C
      VDT=(A-WW*VO-ZW*(VDO+B/WW))*SN/WD
      VDT=EX*((VDO-B/WW)*CS+VDT)+B/WW
C
      VDDT=(B+FV*VO+FVD*VDO-ZW*A)/WD
      VDDT=EX*((A-WW*VO-TZW*VDO)*CS+VDDT*SN)
C
      VO=VT
      VDO=VDT

      IF(PA(1,II+1).GT.TT) GO TO 500
      DT=DT-DELT
      II=II+1
      TO=PA(1,II)
      IF(DT.EQ.0.) GO TO 600
      GO TO 50
C
  500 TO=TO+DT
  600 L=L+1
      X(L)=VT
      IF(L.LT.NTIME) GO TO 10
C
      RETURN

      END

      SUBROUTINE TABD (SD,R,D,RF,A,MSS,MTF,MLD,MST,HED)

      DIMENSION SD(MST,8),R(MSS,MLD),D(MST,MTF),RF(MST,MLD),A(MTF,5)
     1	,HED(MTF,4)
      COMMON/GEN/ NST,NDF,NTF,NLD,NAT,NFQ,NSD,BHED(9),FHED(9),NSS,I3,IS
     1		  ,RLAB(3)
      COMMON /JUNK8/ AI(3)
C
C     COMPUTE FRAME DISPLACEMENTS FROM STRUCTURE DISPLACEMENTS
C
      READ (2) A,D,HED
      REWIND 2
C
      DO 500 K=1,NTF
      I=NTF+1-K
      IF=A(I,1)
      IFC=A(I,2)
      AI(1)=A(I,3)
      AI(2)=A(I,4)
      NT=A(I,5)
      DO 300 L=1,MLD
      DO 300 N=NT,NST
      NN=I3*(N-1)
      AI(3)=-D(N,I)
      DD=0.
      DO 200 J=1,I3
  200 DD=DD+R(NN+J,L)*AI(J+IS)
  300 RF(N,L)=DD
C
      NS=NST-NT+1
      WRITE (2) IF,IFC,NS,((RF(N,L),N=NT,NST),L=1,MLD),(HED(I,J),J=1,4)
  500 CONTINUE
      RETURN
      END
      SUBROUTINE TABP (MTOT)
      COMMON A(1)
      COMMON / GEN1 / NST,NDF,NTF,NLD,NAT,NFQ
      COMMON / JUNK9 / FHED(4),IF,IFC,SPACE(17),II
      COMMON / DYN1 / NTIME,DT,NPC,DAMP
C
C     OUTPUT DISPLACEMENTS AND FORCES
C
      N0=1+2*NST
      CALL TABC(A(N0),NLD)
C
      REWIND 2
      KO=0
      M=0
      MLD=5+NFQ
      IF (NAT.EQ.4) MLD=5+NTIME
      N1=N0+8*NLD
C
      DO 500 I=1,NTF
      II=NTF+1-I
      CALL TABU(A(N1),A(N0),NST,NLD,MLD,NAT)
      IF(IF.EQ.M) GO TO 200
      IF(KO.EQ.0) GO TO 100
      IF(KO.NE.1) GO TO 100
      DO 50 K=1,NBK
  50  BACKSPACE 3
  100 BACKSPACE 3
      READ  (3)  M,NC,NS,NCP,NBP,NFEF,NPAN
      BACKSPACE 3
C
      KO=1
  200 IF(IFC.NE.0) GO TO 500
      IF(KO.NE.2) GO TO 300
      DO 250 K=1,NS
  250 READ (3) XX
C
  300 MM=2*NC
      CALL SECOND (TS)
      NB=NC-1
      NN=4*NC+NS+1
      N2=N1+NST*MLD
      N3=N2+NB
      N4=N3+5*NCP
      N5=N4+5*NBP
      N6=N5+7*NFEF
      N7=N6+NB*NS
      N8=N7+NS*NB*3
      N9=N8+NS*NC
      N10=N9+2*NPAN
      N11=N10+NN*MM
      N12=N11+NN*MLD
      N13=N12+NFEF
      N14=N13+5*NPAN
      IF(N14.GT.MTOT) CALL TABR (N14-MTOT)
      CALL TABO(A(1),A(N0),A(N1),A(N2),A(N3),A(N4),A(N5),A(N6),A(N7),
     1A(N8),A(N9),A(N10),A(N11),NST,NB,NC,NCP,NBP,NS,NFEF,NPAN,A(N12),
     2 A(N13),NN,MM,NLD,MLD,KO)
      CALL SECOND (TE)
      TE=TE-TS
      II=NTF+1-I
      WRITE (6,2000) II,TE
      KO =2
  500 NBK=NS+1
      RETURN
C
 2000 FORMAT (12H0...FRAME NO I3,3H... /
     1	 4X,38HTIME REQUIRED FOR STRESS COMPUTATION = F6.2)
      END
      SUBROUTINE TABC(XM,NLD)
      DIMENSION XM(8,NLD)
C
      WRITE (6,2000)
      DO 100 L=1,NLD
      READ  (5,1000) (XM(I,L),I=1,8)
  100 WRITE (6,2001) L,(XM(I,L),I=1,8)
      WRITE (6,2002)
      RETURN
C
 1000 FORMAT (8F10.0)
 2000 FORMAT (32H1LOAD CONDITION DEFINITION CARDS / 5H0LOAD
     1 11X1HI 10X2HII  9X3HIII 11X1HA 11X1HB 12H  SPECTRUM-1 12H  SPECTR
     1UM-2  12H    RESPONSE )
 2001 FORMAT (I5,8F12.2)
 2002 FORMAT (////43H SPECTRUM-1... ROOT MEAN SQUARE COMBINATION  //
     1	37H SPECTRUM-2... SUM OF ABSOLUTE VALUES  )
C
      END
      SUBROUTINE TABU (U,XM,NST,NLD,MLD,NAT)
C
      DIMENSION U(NST,MLD),XM(8,NLD)
      COMMON /JUNK10 / FHED(4),IF,IFC,NS,UU(8),UMIN(8),NFRM
      COMMON /DYN1 /NTIME,DT,NPC,DAMP
      COMMON /GROUP4/ HD1,HD2
C     DATA HD1,HD2 / 3HMAX,3HMIN /  ******************************
C
C     LOAD CASE COMBINATION AND OUTPUT OF DISPLACEMENTS
C
      READ (2) IF,IFC,NS,((U(N,L),N=1,NS),L=1,MLD),FHED
      IF (IFC.NE.0) GO TO 600
C
      DO 500 LL=1,NLD,8
      LH=LL+7
      IF (LH.GT.NLD) LH=NLD
      IH=LH+1-LL
      WRITE (6,2000) NFRM,IF,FHED
      IF(NAT.GE.3) WRITE (6,3000)
      WRITE (6,2001) (L,L=LL,LH)
C
      DO 400 N=1,NS
      NL=NS+1-N
C	 STATIC DISPLACEMENT COMPONENTS
      DO 100 L=LL,LH
      I=L-LL+1
      UU(I)=0.0
      DO 100 J=1,5
  100 UU(I)=UU(I)+U(N,J)*XM(J,L)
      IF(NAT.GE.3) GO TO 150
      WRITE (6,2002) NL,(UU(I),I=1,IH)
      GO TO 400
C	 DYNAMIC DISPLACEMENT COMPONENTS
  150 NATT=NAT-3
      S1=0.
      S2=0.
      TH=0.
      DO 200 I=6,MLD
      UA=ABS(U(N,I))
      IF(NATT) 160,160,180
  160 S1=S1+UA*UA
      S2=S2+UA
      GO TO 200
  180 IF(UA.GT.TH) TH=UA
  200 CONTINUE
      S1=SQRT(S1)
      DO 250 L=LL,LH
      I=L-LL+1
      UD=S1*XM(6,L)+S2*XM(7,L)+TH*XM(8,L)
      UMIN(I)=UU(I)-UD
  250 UU(I)=UU(I)+UD
      WRITE (6,2003) NL,HD1,(UU(I),I=1,IH)
      WRITE (6,2004)	HD2,(UMIN(I),I=1,IH)
  400 CONTINUE
  500 CONTINUE
C
C     PLOT DYNAMIC DISPLACEMENTS
      IF (NAT.EQ.4) CALL TABPLT (U(1,6),NST,NTIME,DT)
C
  600 RETURN
C
 2000 FORMAT (24H1...OUTPUT FOR FRAME NO I3,4H ... //
     1	10X,12HFRAME TYPE = I3/10X,12HFRAME ID	   4A5/
     2	32H0..LATERAL FRAME DISPLACEMENTS.. )
 2001 FORMAT (6H0LEVEL 7X,8I14)
 2002 FORMAT (I6,7X,8F14.7)
 2003 FORMAT (I6,2X,A3,2X,8F14.7)
 2004 FORMAT (	 8X,A3,2X,8F14.7)
 3000 FORMAT (23H0MAX...STATIC + DYNAMIC /
     1	      23H MIN...STATIC - DYNAMIC )
      END
      SUBROUTINE TABPLT (U,NST,NTIME,DT)
C
C	 PLOT FRAME DISPLACEMENT SHAPES WITH TIME , NAT=4
C
      COMMON /JUNK11/ FHED(4),DUM(2),NS,P(120)
      COMMON /GROUP5/ VERT,STAR,HORIZ,BLK,SL
      DIMENSION U(NST,NTIME),TIME(10)
C     DATA VERT,STAR,HORIZ,BLK,SL/ 1HI,1H*,1H-,1H ,1H/ /********
C
C	 CONTROL VARIABLES
      NPL=10
      NMAX=10
      RMAX=NMAX
      ISPACE=12/(NS+3)
      TO=0.0
      NLINES=NS*(ISPACE+1)+4
      NPP=52/NLINES
C
C	 FIND MAXIMUM ABSOLUTE VALUE
C
      UMAX=0.
      TMAX=0.
      DO 100 I=1,NS
      DO 100 J=1,NTIME
      UM=ABS(U(I,J))
      UU=UM-UMAX
      IF (UU) 100,100,80
   80 UMAX=UM
      TMAX=FLOAT(J)*DT
  100 CONTINUE
      IF(UMAX.NE.0.0) GO TO 110
      WRITE (6,2000)
      RETURN
C
  110 NEWP=0
      DO 500 L=1,NTIME,NPL
      LH=L+NPL-1
      IF(LH.GT.NTIME) LH=NTIME
      IF(NEWP.EQ.0) WRITE (6,1000) FHED
C	 PRINT TIMES
      TIME(1)=TO+DT
      I=1
      LL=L+1
      DO 400 J=LL,LH
      I=I+1
  400 TIME(I)=TIME(I-1)+DT
      TO=TIME(I)
      WRITE (6,1003) (TIME(J),J=1,I)
      NEWP=NEWP+1
      IF(NEWP.EQ.NPP) NEWP=0
C
C	 PLOT SHAPES
      DO 300 N=1,NS
      NPTS=(NMAX+1)*(LH-L+2)-1
      DO 150 I=1,NPTS
  150 P(I)=BLK
      I=0
      DO 200 II=L,LH
      I=I+NMAX+1
      P(I)=VERT
      UU=U(N,II)*RMAX/UMAX
      IF (UU) 205,210,205
  205 UA=ABS(UU)
      UU=(UA+0.5)*UU/UA
  210 NU=UU
  200 P(I+NU)=STAR
C	 PRINT
      WRITE (6,1001) (P(I),I=1,NPTS)
C	 SPACING
      IF (ISPACE) 300,300,220
  220 DO 240 I=1,ISPACE
  240 WRITE (6,1002) (VERT,J=L,LH)
  300 CONTINUE
C	 BASE LINE
      WRITE (6,1001) (HORIZ,I=1,NPTS)
      WRITE (6,1005)
  500 CONTINUE
      WRITE (6,2001) UMAX,TMAX
C
      RETURN
C
C     NOTE...CARRIAGE CONTROL CHARACTER X SUPPRESSES SKIP OVER
C     PAGE FOLD - FORMATS 1001,1002
C
 1000 FORMAT (28H1 FRAME DISPLACEMENT PLOT...  4A5)
 1001 FORMAT (1HX,4X,130A1)
 1002 FORMAT (1HX,4X,10(10X,A1))
 1003 FORMAT (8H0TIME... 10(4X,F7.3))
 1005 FORMAT (/)
 2000 FORMAT (37H DISPLACEMENTS ALL ZERO...NOT PLOTTED )
 2001 FORMAT (19H0SCALE - ONE INCH = E15.6,9X,13HMAXIMUM AT T=	  E15.5/
     1 57H0NOTE..PLOT IS OF DYNAMIC DISPLACEMENTS ONLY AND DOES NOT /
     2 7X,49HINCLUDE ANY SCALING BY LOAD CASE DEFINITION CARDS	)

      END

      SUBROUTINE TABO(SD,XM,U,BW,CP,BP,FEF,LB,LDB,LC,LP,S,R,NST,NB,NC,
     1 NCP,NBP,NS,NFEF,NPAN,IFEF,PP,NN,MM,NLD,MLD,KO)

      DIMENSION BW(NB),CP(5,NCP),BP(5,NBP),FEF(7,NFEF),SD(NST,2),
     1 LB(NS,NB),LDB(NS,NB,3),LC(NS,NC),LP(2,NPAN),IFEF(NFEF),PP(5,NPAN)
     2 ,S(MM,NN),R(NN,MLD),U(NST,MLD),XM(8,NLD)
C
      COMMON /JUNK12/ FHED(4),IF,IFC,ND,NF,LM(6),CA(4,6),F(4,8),Q(3,3),
     1	P(4),SV(5),T(6)
C
C     SET FOUNDATION DISPLACEMENTS AND LATERAL DISPLACEMENTS
C
      IF(KO.EQ.2) GO TO 50
      BACKSPACE 3
      READ  (3) BW,CP,BP,FEF,LB,LDB,LC,LP,IFEF,PP
      BACKSPACE 3
   50 MN=4*NC
      KL=MM+1
      DO 475 L=1,MLD
      DO 425 K=1,MN
  425 R(K,L)=0.0
      DO 450 N=1,NS
      KK=MN+N
  450 R(KK,L)=U(N,L)
  475 R(NN,L)=0.0
C
C     STORY BY STORY  CALCULATION OF MEMBER FORCES
C
      DO 100 I=1,4
      DO 100 J=1,6
  100 CA(I,J)=0.0
      N=NS
C
C     CALCULATE ROTATIONS AND VERTICAL DISPLACEMENT AT LEVEL N
C
  300 BACKSPACE 3
C     READ  (3) (((S(I,J),J=1,NN),(R(I,L),L=1,3)),I=1,MM)
      DO 346 I=1,MM
346   READ (3) (S(I,J),J=1,NN)
      DO 347 I=1,MM
347   READ (3) (R(I,L),L=1,NLD)

      BACKSPACE 3
C
      DO 310 I=1,5
  310 SV(I)=0.
      DO 525 II=1,MM
      I=MM-II+1
      KK=I+1
      DO 525 K=KK,NN
      DO 525 L=1,MLD
  525 R(I,L)=R(I,L)-S(I,K)*R(K,L)
C
C     CALCULATE COLUMN FORCES
C
      LV=NS -N+1
      K=NST-NS
      WRITE (6,2000) FHED,IF,LV,SD(N+K,1)
      WRITE (6,2001)
      NF=4
      ND=6
      DO 500 M=1,NC
      MC=LC(N,M)
      IF(MC.EQ.NCP) GO TO 500
      A=0.0
      XL =SD(N+K,2)
      IF (NB.EQ.0) GO TO 420
      MR=LB(N,M)
      IF (M.EQ.1) GO TO 400
      ML=LB(N,M-1)
      IF (M.EQ.NC) GO TO 410
      A=(BP(5,ML)+BP(5,MR))/2.
      GO TO 420
  400 A=BP(5,MR)
      GO TO 420
  410 A=BP(5,ML)
  420 XL=XL-A
      BB=0.0
      IF ( CP(4,MC) ) 430,430,429
  429 BB=14.4*CP(3,MC)/(XL**2*CP(4,MC))
  430 COMM=2.*CP(1,MC)*CP(3,MC)/(XL*(1.+2.*BB))
      SA=COMM*(2.+BB)
      SB=COMM*(1.-BB)
      SC=CP(2,MC)*CP(1,MC)/XL
      CALL TABZ(SA,SB,SC,XL,A,0.0)
      DO 435 I=1,4
  435 CA(4,I)=-(CA(1,I)+CA(2,I))/XL
      LM(3)=2*M
      LM(1)=LM(3)+MM
      LM(5)=LM(1)-1
      LM(6)=LM(3)-1
      LM(4)=MN+N
      LM(2)=LM(4)+1
      CALL TABW(R,XM,NN,NLD,MLD,M)
      WRITE (6,2005)
      DO 440 I=1,5
  440 SV(I)=SV(I)+F(4,I)
  500 CONTINUE
C
C     CALCULATE BEAM FORCES
C
      IF(NB.EQ.0) GO TO 565
      WRITE (6,2002)
      NF=2
      ND=4
      DO 600 M=1,NB
      MB=LB(N,M)
      IF(MB.EQ.NBP) GO TO 600
      ML=LC(N,M)
      MR=LC(N,M+1)
      A=CP(5,MR)/2.
      B=CP(5,ML)/2.
      XL=BW(M)-A-B
      EIOL=BP(1,MB)*BP(2,MB)/XL
      SA=BP(3,MB)*EIOL
      SB=BP(4,MB)*SA
      CALL TABZ(SA,SB,0.0,XL,A,B)
      LM(1)=2*M
      LM(2)=LM(1)-1
      LM(3)=LM(1)+2
      LM(4)=LM(3)-1
      DO 540 L=1,3
      DO 528 I=1,2
  528 Q(I,L)=0.
      J=LDB(N,M,L)
      IF (J) 540,540,530
  530 V=FEF(5,J)*XL/2.
      YM=V*XL/6.
      Q(1,L)=-FEF(1,J)-YM
      Q(2,L)=+FEF(3,J)+YM
  540 Q(3,L)=0.0
      CALL TABW(R,XM,NN,NLD,MLD,M)
      WRITE (6,2005)
  550 CONTINUE
  600 CONTINUE
C
C     CALCULATE PANEL FORCES
C
      IF(NPAN.EQ.0) GO TO 565
      DO 770 L=1,NPAN
      NP=NS-LP(1,L)+1
      IF(NP.NE.N) GO TO 770
      WRITE (6,2003)
      GO TO 772
  770 CONTINUE
      GO TO 565
  772 NF=4
      ND=6
      DO 800 L=1,NPAN
      NP=NS-LP(1,L)+1
      IF(NP.NE.N) GO TO 800
      M=LP(2,L)
      XL=SD(N+K,2)
      D=BW(M)
      BB=XL**2*PP(4,L)*PP(5,L)
      IF (BB) 730,730,725
  725 BB=6.0*PP(1,L)*PP(3,L)/BB
  730 COMM=2.0*PP(1,L)*PP(3,L)/(XL*(1.+2.*BB))
      SA=COMM*(2.+BB)
      SB=COMM*(1.-BB)
      SC=PP(1,L)*PP(2,L)/XL
C     CALL TABPN (2,SA,SB,SC,XL,D,SS,CA,T)  ********************************
      LM(2)=MN+N
      LM(1)=LM(2)+1
      LM(5)=2*M-1
      LM(6)=LM(5)+2
      LM(3)=LM(5)+MM
      LM(4)=LM(6)+MM
      CALL TABW (R,XM,NN,NLD,MLD,M)
      WRITE (6,2005)
      DO 785 I=1,6
      DO 785 J=1,4
  785 CA(J,I)=0.
      DO 790 I=1,5
  790 SV(I)=SV(I)+F(4,I)
  800 CONTINUE
C
C     SHIFT DISPLACEMENTS
C
  565 DO 570 K=1,MM
      KK=MM+K
      DO 570 L=1,MLD
      R(KK,L)=R(K,L)
  570 R(K,L)=0.0
      WRITE (6,2004) SV
C
  610 N=N-1
      IF (N.NE.0) GO TO 300
C
  810 RETURN
C
 2000 FORMAT (21H1MEMBER FORCES ..... ,9HFRAME ID  4A5,10X,10HFRAME TYPE
     1 I3//21X,8HLEVEL NO I3,3X,3H... 3X,9HLEVEL ID   A5)
 2001 FORMAT      (1X,'0   COL LOAD       BOTTOM-MOMENT     TOP-MOMENT
     1  AXIAL FORCE  ',4X,'SHEAR FORCE'
     2	      )
 2002 FORMAT     (1X,' BEAM   LOAD         LEFT-MOMENT   RIGHT-MOMENT'
     1	    )
 2003 FORMAT (7H PANELS /12H   BAY  LOAD 7X,13HBOTTOM-MOMENT 5X,
     1 10HTOP-MOMENT 4X,11HAXIAL-FORCE 4X,11HSHEAR-FORCE
     2	     )
 2004 FORMAT (31H0 STORY SHEARS   LOAD CASES   I,13X,2HII,13X,3HIII,13X,
     1	1HA,14X,1HB / 20X,5F15.4)
 2005 FORMAT (1H )

      END

      SUBROUTINE TABZ(SA,SB,SC,XL,A,B)

      COMMON /JUNK13/ FHED(4),IF,IFC,ND,NF,LM(6),CA(4,6),F(4,8),T(2,4)
C
C     FORM DISPLACEMENT-MEMBER FORCE TRANSFORMATION MATRIX
C     FOR BEAMS AND COLUMNS
C
      T(2,1)=B/XL
      T(1,1)=1.0+T(2,1)
      T(1,2)=1.0/XL
      T(2,2)=T(1,2)
      T(1,3)=A/XL
      T(2,3)=1.0+T(1,3)
      T(1,4)=-T(1,2)
      T(2,4)=T(1,4)
C
      DO 100 I=1,4
      CA(1,I)=SA*T(1,I)+SB*T(2,I)
  100 CA(2,I)=SB*T(1,I)+SA*T(2,I)
      CA(3,5)=SC
      CA(3,6)=-SC
  120 RETURN

      END

      SUBROUTINE TABW(R,XM,NN,NLD,MLD,M)

      DIMENSION R(NN,MLD),XM(8,NLD)

      COMMON /JUNK14/ FHED(4),IF,IFC,ND,NF,LM(6),CA(4,6),F(4,8),Q(3,3),
     1	P(4),SV(5),T(6),PMIN(4)
      COMMON /GEN2/ FIL(4),NAT,FIL2(26)
      COMMON /GROUP6/ HD1,HD2

C     DATA HD1,HD2 / 3HMAX,3HMIN /************************************
C
C     LOAD CASE COMBINATION AND OUTPUT OF MEMBER FORCES
C
      DO 100 I=1,NF
      DO 100 J=1,8
  100 F(I,J)=0.0
      IF(ND.NE.4) GO TO 150
      DO 120 L=1,3
      F(1,L)=Q(1,L)
  120 F(2,L)=Q(2,L)
C
C     CALCULATE STATIC FORCES
C
  150 DO 200 K=1,ND
      KK=LM(K)
      DO 200 I=1,NF
      DO 200 J=1,5
  200 F(I,J)=F(I,J)+CA(I,K)*R(KK,J)
C
C     CALCULATE DYNAMIC FORCES
C
      NATT=NAT-3
      IF (NATT) 550,250,250
  250 DO 500 I=1,NF
      DO 400 J=6,MLD
      X=0.0
      DO 300 K=1,ND
      KK=LM(K)
  300 X=X+CA(I,K)*R(KK,J)
      XA=ABS(X)
      IF (NATT) 330,330,350
  330 F(I,6)=F(I,6)+XA*XA
      F(I,7)=F(I,7)+XA
      GO TO 400
  350 IF (XA.GT.F(I,8)) F(I,8)=XA
  400 CONTINUE
  500 F(I,6)=SQRT(F(I,6))
C
C     PRINT MEMBER FORCES FOR ALL LOAD CONDITIONS
C
  550 DO 700 L=1,NLD
C	 STATIC FORCE COMPONENTS
      DO 600 I=1,NF
      P(I)=0.
      DO 600 J=1,5
  600 P(I)=P(I)+F(I,J)*XM(J,L)
      IF(NATT) 610,620,620
  610 WRITE (6,2000) M,L,(P(I),I=1,NF)
      GO TO 700
C	 DYNAMIC FORCE COMPONENTS
  620 DO 650 I=1,NF
      PI=F(I,6)*XM(6,L)+F(I,7)*XM(7,L)+F(I,8)*XM(8,L)
      PMIN(I)=P(I)-PI
  650 P(I)=P(I)+PI
      WRITE (6,2001) M,L,HD1,(P(I),I=1,NF)
      WRITE (6,2002)   L,HD2,(PMIN(I),I=1,NF)
  700 CONTINUE
C
      RETURN
C
 2000 FORMAT (2I6,5X,4F15.4)
 2001 FORMAT (2I6,2X,A3,4F15.4)
 2002 FORMAT (6X,I6,2X,A3,4F15.4)

      END

      subroutine second(t)

      write(*,10)
10    format(1x,'  I am not sure what this does but i will
     1            work it out')

       return
      END
